//---------------------------------------------------------------------------
#ifndef pgpmailH
#define pgpmailH
#include "mixmaster.h"
//---------------------------------------------------------------------------
bool  __fastcall HasPgp();
AnsiString __fastcall PgpDir();
//AnsiString __fastcall PgpPublicRing();
//AnsiString __fastcall PgpSecretRing();
//AnsiString __fastcall PgpRemailRing();

const AnsiString NoNameYet = "nonameyet";
#define UFS "$$$$"
#define CFS "\250" // a field separator when presenting key values

bool  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle);
void  __fastcall PgpShutDown();
char* __fastcall GetPgpLibVersion();
char* __fastcall GetPgpLibName();

char* __fastcall PgpSignMessage(char *Message);
char* __fastcall PgpEncryptMessage(char *Message);
char* __fastcall PgpEncryptSignMessage(char *Message);
char* __fastcall PgpDecryptVerifyMessage(char *Message);
char* __fastcall PgpVerifyMessage(char *Message); // need to add to QSpgp
bool  __fastcall PgpIsConventional(char* Message);
char* __fastcall PgpArmorBlockToArmorKeysCpk(char *Keys);

typedef void  __fastcall (*PGPINIT)(HINSTANCE, HINSTANCE, TForm*, HWND);
typedef void  __fastcall (*PGPSHUTDOWN)();
typedef char* __fastcall (*GET_PGPLIBVERSION)();
typedef char* __fastcall (*GET_PGPLIBNAME)();

typedef char* __fastcall (*PGP_SIGNMESSAGE)(char*);
typedef char* __fastcall (*PGP_ENCRYPTMESSAGE)(char*);
typedef char* __fastcall (*PGP_ENCRYPTSIGNMESSAGE)(char*);
typedef char* __fastcall (*PGP_DECRYPTVERIFYMESSAGE)(char*);
typedef char* __fastcall (*PGP_VERIFYMESSAGE)(char*);
typedef bool  __fastcall (*PGP_ISCONVENTIONAL)(char*);
typedef char* __fastcall (*PGP_GETARMORKEYS)(char*);


//obsolete
//typedef int   __fastcall (*PGP_DEARMOR)(BUFFER*, BUFFER*);
//int   __fastcall PgpDearmor(BUFFER *in, BUFFER *out);
//typedef char* __fastcall (*PGP_GETNEWKEYS)(char*,char*); // remailer keyring
//typedef char* __fastcall (*PGP_ADDNEWKEYS)(char*,char*); // remailer keyring
//typedef char* __fastcall (*PGP_PUTARMORKEYS)(char*); // put individually armored keys
//typedef char* __fastcall (*PGP_GETKEYS_IDS)(char*);
//int   __fastcall PgpArmorBlockToBinary(char *Keys);
//char* __fastcall PgpArmorKeysToArmorBlock(char *Keys);
//char* __fastcall PgpArmorBlockToArmorKeys(char *Keys);
//char* __fastcall PgpArmorBlockToArmorKeysPlus(char *Keys);
//char* __fastcall PgpArmorBlockToArmorKeysCpkDesc(char *Keys);
//typedef void  __fastcall (*PGP_OPENKEYSWIN)();
//typedef bool  __fastcall (*PGP_IMPORTREPLACE)(char*,char*,char*,bool);
//typedef bool  __fastcall (*PGP_IMPORTADDNEW)(char*,char*,char*,bool);
//char* __fastcall PgpGetUserIdsKeyIds(char *KeyFile);
//void  __fastcall OpenPgpKeysWindow(TForm *Owner);
//bool  __fastcall PgpImportKeysReplace(char *importfile, char *pubring,
//   char *secring, bool deleteImportfile);
//bool  __fastcall PgpImportKeysAddNew(char *importfile, char *pubring,
//   char *secring, bool deleteImportfile);
//char* __fastcall PgpGetNewRemailerKeys(char *KeyDoc, char *Type1);
//char* __fastcall PgpAddNewRemailerKeys(char *KeyDoc, char *Type1);

//---------------------------------------------------------------------------
extern HINSTANCE hPgpLib;
//extern int pgpcnt;
#endif
