//---------------------------------------------------------------------------
#ifndef PopAccDlgH
#define PopAccDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "Pop3Prot.hpp"
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
class TPopAcctDlg : public TForm
{
__published:	// IDE-managed Components
  TPanel *Panel1;
  TButton *NewBtn;
  TButton *EditBtn;
  TButton *DeleteBtn;
  TButton *CancelBtn;
  TPanel *Panel2;
  THeaderControl *HeaderControl1;
  TListBox *Accts;
  TPopupMenu *PopupMenu;
  TMenuItem *PopGetMailItem;
  TMenuItem *PopGetThisItem;
  TMenuItem *PopToggleItem;
  TMenuItem *N1;
  TSpeedButton *AcctUp;
  TSpeedButton *AcctDn;
  TLabel *Label1;
  TMenuItem *PopNewItem;
  TMenuItem *PopOpenItem;
  TMenuItem *PopDeleteItem;
  TMenuItem *N2;
  TCheckBox *GetEveryLast;
  TButton *OkBtn;
  TBitBtn *GetBtn;
  TButton *HelpBtn;
  void __fastcall AcctsDrawItem(TWinControl *Control, int Index, TRect &Rect,
     TOwnerDrawState State);
  void __fastcall HeaderControl1DrawSection(THeaderControl *HeaderControl,
     THeaderSection *Section, const TRect &Rect, bool Pressed);
  void __fastcall AcctsMouseDown(TObject *Sender, TMouseButton Button,
     TShiftState Shift, int X, int Y);
  void __fastcall AcctsKeyPress(TObject *Sender, char &Key);
  void __fastcall HeaderControl1SectionClick(THeaderControl *HeaderControl,
     THeaderSection *Section);
  void __fastcall NewBtnClick(TObject *Sender);
  void __fastcall EditBtnClick(TObject *Sender);
  void __fastcall AcctsClick(TObject *Sender);
  void __fastcall DeleteBtnClick(TObject *Sender);
  void __fastcall GetBtnClick(TObject *Sender);
  void __fastcall PopupMenuPopup(TObject *Sender);
  void __fastcall PopToggleItemClick(TObject *Sender);
  void __fastcall AcctDnClick(TObject *Sender);
  void __fastcall AcctUpClick(TObject *Sender);
  void __fastcall AcctsDblClick(TObject *Sender);
  void __fastcall PopGetThisItemClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
  void __fastcall ShowHint(TObject *Sender);
public:		// User declarations
  RECT r;
  bool modified;
  TForm *MainForm;
  TPoint LastMouse;
  TStrings *accts;
  __fastcall TPopAcctDlg(TComponent* Owner);
  __fastcall virtual ~TPopAcctDlg();
  void __fastcall PaintItem(int Index);
  void __fastcall DrawCheck(TCanvas *Canvas, TRect &Rect, TColor Color);
  void __fastcall AcctsDrawItemCanvas(TCanvas *Canvas, int Index, TRect &Rect,
     TOwnerDrawState State);
  void __fastcall Set(int Index, AnsiString &token, AnsiString &value);
  AnsiString __fastcall Get(int Index, AnsiString &token);
  AnsiString __fastcall Password(int Index);
  AnsiString __fastcall Account(int Index);
  bool __fastcall Checked(int Index);
  bool __fastcall Remember(int Index);
  bool __fastcall PgpOnly(int Index);
  bool __fastcall Delete(int Index);
  int  __fastcall CheckCount();
  void __fastcall SyncAccts();
  void __fastcall SetLB(int ForCount);
  void __fastcall PaintAccounts(int first=0, int last=-1);
  void __fastcall InvalidateItem(int Index);
};
//---------------------------------------------------------------------------
extern TPopAcctDlg *PopAcctDlg;
//---------------------------------------------------------------------------
#endif
